﻿namespace Butterfly.HabboHotel.Items
{
    using Butterfly;
    using Butterfly.HabboHotel.Catalogs;
    using Butterfly.HabboHotel.Habbo.Guilds;
    using Butterfly.Messages;
    using System;
    using System.Collections.Generic;

    internal class UserItem
    {
        internal uint BaseItem;
        internal string ExtraData;
        internal string Group_data;
        internal List<string> Guilds_Data = new List<string>();
        internal uint Id;
        internal bool isWallItem;
        private Item mBaseItem;
        internal uint RareId;

        internal UserItem(uint Id, uint BaseItem, string ExtraData, uint rareid, string groupstring)
        {
            this.Id = Id;
            this.BaseItem = BaseItem;
            this.ExtraData = ExtraData;
            this.mBaseItem = this.GetBaseItem();
            if (this.mBaseItem == null)
            {
            }
            this.isWallItem = this.mBaseItem.Type == 'i';
            this.RareId = rareid;
            this.Group_data = groupstring;
            if (this.Group_data.Length > 0)
            {
                foreach (string str in this.Group_data.Split(new char[] { ';' }))
                {
                    this.Guilds_Data.Add(str);
                }
            }
        }

        internal Item GetBaseItem()
        {
            return ButterflyEnvironment.GetGame().GetItemManager().GetItem(this.BaseItem);
        }

        internal CatalogItem GetRareCatalogItem(uint ItemId)
        {
            return ButterflyEnvironment.GetGame().GetCatalog().RaresItems[ItemId];
        }

        internal void SerializeFloor(ServerMessage Message, bool Inventory)
        {
            Message.AppendInt32(this.Id);
            Message.AppendString(this.mBaseItem.Type.ToString().ToUpper());
            Message.AppendInt32(this.Id);
            Message.AppendInt32(this.GetBaseItem().SpriteId);
            if (this.mBaseItem.AllowGroupItem)
            {
                Message.AppendInt32(0x11);
            }
            else if (this.mBaseItem.InteractionType == InteractionType.musicdisc)
            {
                Message.AppendInt32(8);
            }
            else
            {
                Message.AppendInt32(1);
            }
            if (this.RareId > 0)
            {
                Message.AppendString("");
                Message.AppendBoolean(true);
                Message.AppendBoolean(false);
            }
            else if (this.mBaseItem.AllowGroupItem)
            {
                try
                {
                    MyGuild guild = ButterflyEnvironment.GetGame().GetGuilds().GetGuild(int.Parse(this.Guilds_Data[0]));
                    if (guild == null)
                    {
                        Message.AppendInt32(0);
                    }
                    else
                    {
                        Message.AppendInt32(2);
                        Message.AppendInt32(5);
                        Message.AppendString("0");
                        Message.AppendString(guild.Id.ToString());
                        Message.AppendString(guild.Image);
                        Message.AppendString(this.Guilds_Data[1]);
                        Message.AppendString(this.Guilds_Data[2]);
                    }
                }
                catch
                {
                    Message.AppendInt32(0);
                }
            }
            else
            {
                Message.AppendInt32(0);
            }
            if (this.mBaseItem.InteractionType == InteractionType.musicdisc)
            {
                Message.AppendString("");
            }
            else if (!this.mBaseItem.AllowGroupItem)
            {
                Message.AppendString(this.ExtraData);
            }
            if (this.RareId > 0)
            {
                Message.AppendInt32(this.RareId);
                Message.AppendInt32(this.GetRareCatalogItem(this.BaseItem).LimitedStack);
            }
            Message.AppendBoolean(this.GetBaseItem().AllowRecycle);
            Message.AppendBoolean(this.GetBaseItem().AllowTrade);
            if (this.RareId > 0)
            {
                Message.AppendBoolean(false);
            }
            else
            {
                Message.AppendBoolean(this.GetBaseItem().AllowInventoryStack);
            }
            Message.AppendBoolean(Marketplace.CanSellItem(this));
            Message.AppendInt32(-1);
            Message.AppendString("");
            Message.AppendInt32(0);
        }

        internal void SerializeWall(ServerMessage Message, bool Inventory)
        {
            Message.AppendInt32(this.Id);
            Message.AppendString(this.mBaseItem.Type.ToString().ToUpper());
            Message.AppendInt32(this.Id);
            Message.AppendInt32(this.GetBaseItem().SpriteId);
            if (this.GetBaseItem().Name.Contains("a2"))
            {
                Message.AppendInt32(3);
            }
            else if (this.GetBaseItem().Name.Contains("wallpaper"))
            {
                Message.AppendInt32(2);
            }
            else if (this.GetBaseItem().Name.Contains("landscape"))
            {
                Message.AppendInt32(4);
            }
            else
            {
                Message.AppendInt32(1);
            }
            int i = 0;
            if ((this.GetBaseItem().InteractionType == InteractionType.gift) && this.ExtraData.Contains(Convert.ToChar(5).ToString()))
            {
                int num2 = int.Parse(this.ExtraData.Split(new char[] { '\x0005' })[1]);
                int num3 = int.Parse(this.ExtraData.Split(new char[] { '\x0005' })[2]);
                i = (num2 * 0x3e8) + num3;
            }
            Message.AppendInt32(i);
            Message.AppendString(this.ExtraData);
            Message.AppendBoolean(this.GetBaseItem().AllowRecycle);
            Message.AppendBoolean(this.GetBaseItem().AllowTrade);
            Message.AppendBoolean(this.GetBaseItem().AllowInventoryStack);
            Message.AppendBoolean(Marketplace.CanSellItem(this));
            Message.AppendInt32(-1);
        }
    }
}

