﻿namespace Butterfly.HabboHotel.RoomBots
{
    using Butterfly;
    using Butterfly.Core;
    using Butterfly.HabboHotel.GameClients;
    using Butterfly.HabboHotel.Rooms;
    using Butterfly.Messages;
    using HabboEvents;
    using System;
    using System.Drawing;

    internal class GenericBot : BotAI
    {
        private int ActionTimer;
        private int SpeechTimer;

        internal GenericBot(int VirtualId)
        {
            this.SpeechTimer = new Random((VirtualId ^ 2) + DateTime.Now.Millisecond).Next(10, 250);
            this.ActionTimer = new Random((VirtualId ^ 2) + DateTime.Now.Millisecond).Next(10, 30);
        }

        internal override void OnSelfEnterRoom()
        {
        }

        internal override void OnSelfLeaveRoom(bool Kicked)
        {
        }

        internal override void OnTimerTick()
        {
            if (base.GetBotData() != null)
            {
                if (this.SpeechTimer <= 0)
                {
                    if (base.GetBotData().RandomSpeech.Count > 0)
                    {
                        RandomSpeech randomSpeech = base.GetBotData().GetRandomSpeech();
                        base.GetRoomUser().Chat(null, randomSpeech.Message, randomSpeech.Shout, 0);
                    }
                    this.SpeechTimer = ButterflyEnvironment.GetRandomNumber(10, 300);
                }
                else
                {
                    this.SpeechTimer--;
                }
                if (this.ActionTimer > 0)
                {
                    this.ActionTimer--;
                }
                else
                {
                    switch (base.GetBotData().WalkingMode.ToLower())
                    {
                        case "freeroam":
                        {
                            Point point = base.GetRoom().GetGameMap().getRandomWalkableSquare();
                            base.GetRoomUser().MoveTo(point.X, point.Y);
                            break;
                        }
                        case "specified_range":
                        {
                            Point point2 = base.GetRoom().GetGameMap().getRandomWalkableSquare();
                            base.GetRoomUser().MoveTo(point2.X, point2.Y);
                            break;
                        }
                    }
                    this.ActionTimer = ButterflyEnvironment.GetRandomNumber(1, 30);
                }
            }
        }

        internal override void OnUserEnterRoom(RoomUser User)
        {
        }

        internal override void OnUserLeaveRoom(GameClient Client)
        {
        }

        internal override void OnUserSay(RoomUser User, string Message)
        {
            if (Gamemap.TileDistance(base.GetRoomUser().X, base.GetRoomUser().Y, User.X, User.Y) <= 8)
            {
                BotResponse response = base.GetBotData().GetResponse(Message);
                if (response != null)
                {
                    string str = response.ResponseType.ToLower();
                    if (str != null)
                    {
                        if (!(str == "say"))
                        {
                            if (str == "shout")
                            {
                                base.GetRoomUser().Chat(null, response.ResponseText, true, 0);
                            }
                            else if (str == "whisper")
                            {
                                ServerMessage message = new ServerMessage(Outgoing.Whisp);
                                message.AppendInt32(base.GetRoomUser().VirtualId);
                                message.AppendString(response.ResponseText);
                                message.AppendInt32(0);
                                message.AppendInt32(0);
                                message.AppendInt32(0);
                                message.AppendInt32(-1);
                                User.GetClient().SendMessage(message);
                            }
                        }
                        else
                        {
                            base.GetRoomUser().Chat(null, response.ResponseText, false, 0);
                        }
                    }
                    if (response.ServeId >= 1)
                    {
                        User.CarryItem(response.ServeId);
                    }
                }
            }
        }

        internal override void OnUserShout(RoomUser User, string Message)
        {
            if (ButterflyEnvironment.GetRandomNumber(0, 10) >= 5)
            {
                base.GetRoomUser().Chat(null, LanguageLocale.GetValue("onusershout"), true, 0);
            }
        }
    }
}

